import { BaseDataSource } from "./BaseDataSource";
import { IPageCandidatesSink } from "./IPageCandidatesSink";
import { PagePredictionEngine } from "./PagePredictionEngine";
import { IDataSourceDataProvider } from "./IDataSourceDataProvider";
import { IDataSourceVirtualDataProvider } from "./IDataSourceVirtualDataProvider";
import { IExternalVirtualDataSource } from "./IExternalVirtualDataSource";
import { Type } from "./type";
import { DataSourcePageRequestPriority } from "./DataSourcePageRequestPriority";
import { DataSourceRowType } from "./DataSourceRowType";
export declare class VirtualDataSource extends BaseDataSource implements IPageCandidatesSink {
    constructor();
    private bw;
    protected b6: PagePredictionEngine;
    protected get_g(): IDataSourceDataProvider;
    protected readonly g: IDataSourceDataProvider;
    private bz;
    b1: IDataSourceVirtualDataProvider;
    private by;
    b0: IDataSourceVirtualDataProvider;
    private cj;
    cp: number;
    protected c3(): void;
    protected c4(): void;
    private ci;
    co: number;
    protected cc: boolean;
    private cf;
    ck: number;
    private ca;
    protected get_isSortingSupported(): boolean;
    readonly isSortingSupported: boolean;
    protected get_isFilteringSupported(): boolean;
    readonly isFilteringSupported: boolean;
    protected get_isGroupingSupported(): boolean;
    readonly isGroupingSupported: boolean;
    private b3;
    b4: IExternalVirtualDataSource;
    protected b2(): IDataSourceVirtualDataProvider;
    protected bq(a: string, b: any, c: any): void;
    private cm(a);
    private cx(a, b, c);
    private c1(a, b, c);
    protected ag(a: number): number;
    private c0();
    private cz(a);
    private cl(a);
    private cy(a);
    protected get_isVirtual(): boolean;
    readonly isVirtual: boolean;
    private b9;
    private ce;
    private cb;
    private bu;
    isPlaceholderItem(a: number): boolean;
    getItemAtIndex(a: number): any;
    private cq(a);
    private bx(a);
    private b8;
    private b7(a);
    getItemPropertyAtIndex(a: number, b: string): any;
    private cr(a, b);
    addCandidate(a: number, b: DataSourcePageRequestPriority): boolean;
    removeCandidate(a: number): void;
    cn(): number;
    bo(a: number, b: any, c: any): void;
    protected bs(): void;
    private c2();
    be(): void;
    bi(a: number, b: any): void;
    bl(a: number, b: any): void;
    protected get_isItemIndexLookupSupported(): boolean;
    readonly isItemIndexLookupSupported: boolean;
    protected get_isKeyIndexLookupSupported(): boolean;
    readonly isKeyIndexLookupSupported: boolean;
    indexOfItem(a: any): number;
    private cd(a, b);
    indexOfKey(a: any[]): number;
    private b5();
    getStickyRowPriority(a: number): number;
    unpinRow(a: any[]): void;
    pinRow(a: any[]): void;
    isRowPinned(a: number): boolean;
    private bv;
    private ch;
    private cg;
    getStickyRows(): number[];
    isExclusivelySticky(a: number): boolean;
    getRowType(a: number): DataSourceRowType;
    static $t: Type;
}
